%{ open Ast %}

%token <int> NUM
%token PLUS
%token TIMES
%token MINUS
%token LPAREN
%token RPAREN
%token EOL

%left PLUS MINUS
%left TIMES

%start prog
%type <Ast.exp> prog

%%

exp:
    n=NUM                               { (* n *) Num n }
  | e1=exp; PLUS; e2=exp                { (* e1 + e2 *) Binop (Plus, e1, e2)}
  | e1=exp; MINUS; e2=exp                { (*  e1 - e2 *) Binop (Minus, e1, e2) }
  | e1=exp; TIMES; e2=exp               { (* e1 * e2 *) Binop (Times, e1, e2) }
  | LPAREN; e=exp; RPAREN               { e }
;


prog:
    e=exp; EOL                          { e }
;
